package com.heda.apk_admin.core.services;

import android.app.Activity;
import android.app.ActivityManager;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;

public class ApkController extends Activity {
    private Context _context;

    public ApkController(Context context) {
        _context = context;
    }

    public String launchApp(String packageName, boolean forcePlayStore) {
        String result;
        PackageManager packageManager = _context.getPackageManager();
        Intent launchApp = packageManager.getLaunchIntentForPackage(packageName);
        if (launchApp == null || forcePlayStore) {
            launchApp = new Intent(Intent.ACTION_VIEW);
            launchApp.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            String appStoreUrl = "market://details?id=";
            String browserUrl = "https://play.google.com/store/apps/details?id=";
            try {
                launchApp.setData(Uri.parse(appStoreUrl + packageName));
                _context.startActivity(launchApp);
                result = "OpenedInGooglePlay";
            } catch (Exception e) {
                launchApp.setData(Uri.parse(browserUrl + packageName));
                _context.startActivity(launchApp);
                result = "OpenedInBrowser";
            }
        } else {
            launchApp.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            _context.startActivity(launchApp);
            result = "OpenedInDevice";
        }
        return result;
    }

    public void uninstallApp(String packageName) {
        Intent uninstallApp = new Intent(Intent.ACTION_DELETE);
        uninstallApp.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        uninstallApp.setData(Uri.parse("package:" + packageName));
        _context.startActivity(uninstallApp);
    }
}
