package com.heda.apk_admin.views;

import android.content.Context;

import androidx.annotation.NonNull;

import com.heda.apk_admin.core.models.ChannelError;
import com.heda.apk_admin.core.services.ApkController;
import com.heda.apk_admin.utils.ChannelErrorHandler;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

public class ApkControllerViewer implements MethodCallHandler {
    public Context context;

    public ApkControllerViewer(Context context) {
        this.context = context;
    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
        String packageName = call.argument("packageName");
        ApkController apkController = new ApkController(context);
        try {
            switch (call.method) {
                case "launchApp": {
                    boolean forceAppStore = call.hasArgument("forceAppStore") && (boolean) call.argument("forceAppStore");
                    String openOperationResult = apkController.launchApp(packageName, forceAppStore);
                    result.success(openOperationResult);
                }
                break;
                case "uninstallApp": {
                    apkController.uninstallApp(packageName);
                    result.success("OK");

                }
                break;
                default:
                    result.notImplemented();
            }
        } catch (Exception e) {
            ChannelErrorHandler errorHandler = new ChannelErrorHandler();
            ChannelError channelError = errorHandler.handleChannelException(e);
            result.error(channelError.hashCode, channelError.message, channelError.cause);
        }
    }
}
