package com.heda.apk_admin.views;

import android.app.Activity;
import android.content.Context;

import androidx.annotation.NonNull;

import com.heda.apk_admin.core.models.ChannelError;
import com.heda.apk_admin.core.services.ApkExporter;
import com.heda.apk_admin.utils.ChannelErrorHandler;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

public class ApkExporterViewer implements MethodCallHandler {
    private Context context;
    public Activity activity;

    public ApkExporterViewer(Context context) {
        this.context = context;
    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
        ApkExporter apkExporter = new ApkExporter(context, activity);
        try {
            if (call.method.equals("shareAppViaBluetooth")) {
                String packageName = call.argument("packageName");
                String shareResult = apkExporter.shareAppViaBluetooth(packageName);
                result.success(shareResult);
            } else if (call.method.equals("shareAppLink")) {
                String packageName = call.argument("packageName");
                apkExporter.shareAppLink(packageName);
                result.success("OK");
            } else result.notImplemented();
        } catch (Exception e) {
            ChannelErrorHandler errorHandler = new ChannelErrorHandler();
            ChannelError channelError = errorHandler.handleChannelException(e);
            result.error(channelError.hashCode, channelError.message, channelError.cause);
        }
    }
}
